/*******************************************************************************

NAME            ecc.h
VERSION         %version:  2%
UPDATE DATE     %date_modified: Mon Aug 15 10:11:02 2016 %
PROGRAMMER      %created_by:    tish %

        Copyright 2016 NetApp, Inc. All Rights Reserved.

DESCRIPTION:
    Provides definitions needed to access ECC functions by ecc_ops.c.

*******************************************************************************/

#ifndef __INCecc
#define __INCecc


/***  INCLUDES  ***/
#include "linux/kernel.h"
#include "linux/printk.h"
#include "linux/types.h"

/***  CONSTANT DEFINITIONS  ***/
#define mce_printk(v, s, a...) do {       \
        if (!(mce_in_progress))   \
            printk(v s, ##a);       \
        } while (0)

/* Bitmap defines for return values */
#define ECC_UNCOR   0x00000001
#define ECC_COR     0x00000002
#define ECC_IN_RPA  0x00000004
#define MCE_UNCOR   0x00000008
#define MCE_COR     0x00000010
#define MCE_UNKNOWN 0x00000020

/***  TYPE DEFINITIONS  ***/
extern bool mce_in_progress;

/***  GLOBALS  ***/
bool      enable_patrol_scrub(bool enable);
void      ecc_inject(uint64_t maddr, uint8_t bit, uint8_t immediate);
bool      mce_mb_enabled(void);
void      mce_enable_mb(bool enable);
uint32_t  ntap_check_for_errors(bool log_enable);
int       ecc_init(void);


#endif        /* End of __INCecc */

